module Bags(Bag,bag2list,list2bag,empty,insert) where
import Monad

newtype Bag a = B {bag2list :: [a]}

list2bag :: [a] -> Bag a
list2bag = B

empty :: Bag a
empty =  B []

insert :: a -> Bag a -> Bag a
insert x = list2bag . (x :) . bag2list

instance Eq a => Eq (Bag a) where
  x == y = bageq (bag2list x) (bag2list y)

bageq []     []    =  True
bageq []     (_:_) =  False
bageq (_:_)  []    =  False
bageq (x:xs) ys    =  maybe False (bageq xs) (checkIn x ys)

checkIn :: Eq a => a -> [a] -> Maybe [a]
checkIn a as | null rest = Nothing
	     | otherwise = Just (nota++tail rest)
  where (nota,rest) = span (/=a) as

instance Monad Bag where
  return      =  B . return
  B xs >>= f  =  B (xs >>= bag2list . f)

instance MonadPlus Bag where
  mzero              =  B []
  B xs `mplus` B ys  =  B (xs `mplus` ys)

instance Show a => Show (Bag a) where
  showsPrec n (B xs) s = 'B':showsPrec n xs s
