module KleisliArrowInstances where
import ArrowPlus
import MonadTools((@@),strength1,strength2,liftM0,liftM,MonadPlus(..))
import ArrowTypes(Kleisli(Kleisli))

-- --------------------------------------------------------------
instance Monad m => Arrow (Kleisli m) where
  arr f = Kleisli (f >>> return)
  Kleisli f >>> Kleisli g = Kleisli (g @@ f)
  Kleisli f <<< Kleisli g = Kleisli (f @@ g)
  first  (Kleisli f) = Kleisli (first f  >>> strength1)
  second (Kleisli f) = Kleisli (second f >>> strength2)

instance Monad m => ArrowChoice (Kleisli m) where
  Kleisli f ||| Kleisli g = Kleisli (f ||| g)

instance MonadPlus m => ArrowZero (Kleisli m) where
  zeroA = Kleisli (const mzero)

instance MonadPlus m => ArrowPlus (Kleisli m) where
--  Kleisli f <|> Kleisli g = Kleisli (\x-> (f x >>= return . Left) `mplus` (g x >>= return . Right)) 
  Kleisli f <|> Kleisli g = Kleisli (\x-> (liftM Left (f x)) `mplus` (liftM Right (g x)))
  Kleisli f <+> Kleisli g = Kleisli (\x-> f x `mplus` g x) 

